Name:           u-boot-aboot
Version:        2022.07
Release:        2%{?dist}
Summary:        U-boot with android boot support

License:        GPL-2.0+

Source0:        https://source.denx.de/u-boot/u-boot/-/archive/v2022.07/u-boot-v2022.07.tar.gz
Patch1:         u-boot-get-partition-type-guid.patch
Patch2:         u-boot-auto-aboot.patch

BuildRequires:  gcc make swig bison flex python3-devel openssl-devel python3-setuptools

%define debug_package %{nil}

%ifarch aarch64
%define uboot_arch arm64
%define uboot_config qemu_%{uboot_arch}_defconfig
%else
%define uboot_arch %{_arch}
%define uboot_config qemu-%{uboot_arch}_defconfig
%endif

%description
U-boot with android boot support

%prep
%setup -q -n u-boot-v%{version}
%patch1 -p1
%patch2 -p1

echo 'CONFIG_ANDROID_BOOT_IMAGE=y' >> configs/%{uboot_config}
echo 'CONFIG_CMD_ABOOTIMG=y' >> configs/%{uboot_config}
echo 'CONFIG_CMD_ADTIMG=y' >> configs/%{uboot_config}
echo 'CONFIG_CMD_AB_SELECT=y' >> configs/%{uboot_config}
echo 'CONFIG_CMD_BCB=y' >> configs/%{uboot_config}
echo 'CONFIG_CMD_GPT=y' >> configs/%{uboot_config}
echo 'CONFIG_PARTITION_TYPE_GUID=y' >> configs/%{uboot_config}

%build
make %{uboot_config}
make -j$(nproc)

%install
mkdir -p $RPM_BUILD_ROOT/boot
cp u-boot.bin $RPM_BUILD_ROOT/boot/
cp u-boot.rom $RPM_BUILD_ROOT/boot/

%files
/boot/u-boot.bin
/boot/u-boot.rom

%changelog
* Fri Aug 26 2022 Alexander Larsson <alexl@redhat.com> - 2022.07-2
- Auto-boot aboot partitions

* Wed Aug 17 2022 Alexander Larsson <alexl@redhat.com>
- Initial version
